(* Prepares pari script to extract an invariant subspace of the 
   solution space, based on a Hecke operator and a factor of its 
   characteristic polynomial.
*)

program hecke ( input,output,lnkone,lnktwo )

; const
    maxparams	= 6000
  ; maxdim	= 200     (* changed 4-9-93 by Bert *)


; var
    lnkone,lnktwo    :text
  ; d,params,dim	: integer
  ; soln		: array [1..maxdim,1..maxparams] of integer
  ; freepar		: array [1..maxdim] of integer




(**********************************************************************)
(*                                                                    *)
(*                       input/output routines                        *)
(*                                                                    *)
(**********************************************************************)

; procedure readsolnspace
  ; var
    i,s : integer
  ; begin
    ; reset(lnktwo,'lnktwo')
    ; readln(lnktwo,d)
    ; readln(lnktwo,params)
    ; readln(lnktwo,dim)
    ; if dim>0 then
      begin
        for s := 1 to dim do read(lnktwo,freepar[s])
      ; for s := 1 to dim do
        begin
          for i := 1 to params do read(lnktwo,soln[s,i])
        ; readln(lnktwo)
        end
      end
    end

; procedure insertheckematrix (* transposed, actually *)
    ; procedure siftrat{ Simple minded sifting of rationals.} 
      ; var
          ch:char;
          partofnumber:set of char;
      begin
        partofnumber:=['-','0'..'9','/']{I have removed '+'.} 
      ; ch:=lnkone^
      ; while (not eof(lnkone)) and not ( ch in partofnumber) do begin 
          get(lnkone)
        ; ch:=lnkone^
        end{while}
      ; if not eof(lnkone) then
          begin
            repeat
            ; write(ch)
            ; get(lnkone)
            ; ch:=lnkone^
            until (eoln(lnkone) or (not ( ch in partofnumber)))
            ; writeln
          end
      end{siftrat}
  ; begin
    ; reset(lnkone,'lnkone')
    ; writeln('m=matrix(',dim,',',dim,',X,Y,read());0;') 
    ; repeat
        siftrat
      until eof(lnkone)
    end

; procedure writesolmat
  ; var
      s,t : integer
  ; begin
    ; writeln('dim=',dim:1,';')
    ; writeln('freeparold=vector(',dim,',X,read());0;')
    ; for s := 1 to dim do
      begin
        writeln(freepar[s]:1)
      end
    ; writeln('m=matrix(',params,',',dim,',X,Y,read());0;')
    ; for s := 1 to dim do
      for t := 1 to params do
      begin
        writeln(soln[s,t]:1) (* pari will read column by column *) 
      end
    ; for s := 1 to dim do
    end


; procedure writeinit
  ; begin
    ; writeln('\prompt=')
    ; writeln('\format=g0.3')
    ; writeln('\p')
    ; writeln('\p')
    ; writeln('\prompt=')
    ; writeln('print()')
    ; writeln('\prompt=d=')
    ; writeln('\prompt=')
    ; writeln(d:1,';')
    ; writeln('\a')
    ; writeln('\w nwsl')
    ; writeln('\prompt=params=')
    ; writeln('\prompt=')
    ; writeln('params=',params:1,';')
    ; writeln('\a')
    ; writeln('\w nwsl')
    ; writeln('\prompt=olddim=')
    ; writeln('\prompt=')
    ; writeln(dim:1,';')
    ; writeln('\a')
    ; writesolmat
    ; writeln('sol=m;0;')
    ; writeln('m=matrix(dim,dim,X,Y,m[freeparold[X],Y]);0;\')
    ; writeln('sx=m^(-1);0;')
    ; writeln('den=denom(sx);')
    ; writeln('g=den*sx;0;')
    ; writeln('sol=sol*g;0;')
    ; insertheckematrix
    ; writeln('x=m~;0;')
    ; writeln('\r sbfctr')
    ; writeln('sx=%;0;')
    ; writeln('den=denom(sx);')
    ; writeln('sx=den*sx;0;')
    ; writeln('m=sol*keri(sx);0;')
    ; writeln('sol=m;0;')
    ; writeln('\prompt=newdim=')
    ; writeln('\prompt=')
    ; writeln('dim=matsize(m)[2];')
    ; writeln('\a')
    ; writeln('\w nwsl')
 ; writeln('m=matrix(params,dim,X,Y,lift(mod(sol[X,Y]+4500,224737))-4500);0;')
    ; writeln('myrows=indexrank(sol)[1];0;')
    ; writeln('until(pos<1,\')  (* This pari loop could be infinite *)
    ; writeln('try=matrix(matsize(myrows)[2],dim,X,Y,m[myrows[X],Y]);\')
    ; writeln('try=concat(try,224737*idmat(matsize(try)[1]));\')
    ; writeln('g=lllint(try);\')
    ; writeln('g=matrix(dim,dim,X,Y,g[X,Y]);\')
    ; writeln('try=m*g;\')
    ; writeln('pos=0;\')
    ; writeln('for(X=1,params,\')
    ; writeln('if(sum(0,Y=1,dim,lift(mod(try[X,Y]+4500,224737))>9000)>0,\')
    ; writeln('pos=X,));\')
    ; writeln('myrows=concat(myrows,[pos])\')
    ; writeln(')')
    ; writeln('m=matrix(params,dim,X,Y,lift(mod(try[X,Y]+4500,224737))-4500)')
    ; writeln('if(rank(m)==rank(concat(m,sol)),sol=m,)')
    ; writeln('freepar=indexrank(sol)[1];')
    ; writeln('\a')
    ; writeln('\w nwsl')
    ; writeln('sol~;')
    ; writeln('\a')
    ; writeln('\w nwsl')
    end


; begin
  ; readsolnspace
  ; writeinit
  ; writeln('\q')
  end.
